package ggs.ggsa._skat;

import ggs.ggsa.main.Global;
import ggs.shared.*;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Observable;
import java.util.Observer;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

public class SkatTabPanel extends JPanel implements Observer
{

  public SkatTabPanel(Skat skatService)
  {
    initComponents(skatService);
    skatService.addObserver(this);
  }

  private void initComponents(final Skat skatService)
  {
    setLayout(new BorderLayout());

    // the north panel
    JPanel northPanel = new JPanel();
    FlowLayout flowLayout = new FlowLayout();
    flowLayout.setAlignment(FlowLayout.LEFT);
    northPanel.setLayout(flowLayout);

    JButton newButton = new JButton("Create table");
    newButton.addMouseListener(new MouseAdapter()
    {
      public void mouseClicked(MouseEvent evt)
      {
	skatService.sendCreateTable();
      }
    });
    northPanel.add(newButton);

    add(northPanel, BorderLayout.NORTH);
    
    // the west panel
    JPanel westPanel = new JPanel();
    flowLayout = new FlowLayout();
    flowLayout.setHgap(5);
    flowLayout.setVgap(5);
    flowLayout.setAlignment(FlowLayout.LEFT);
    westPanel.setLayout(flowLayout);

    JTable tableTable = new JTable(new TableDataModel(skatService));
    tableTable.setPreferredScrollableViewportSize(new Dimension(500, 250));
    JScrollPane scrollPane = new JScrollPane(tableTable);
    westPanel.add(scrollPane);

    add(westPanel, BorderLayout.WEST);
    
    // center panel
    JPanel centerPanel = new JPanel();
    GridLayout gridLayout = new GridLayout();
    gridLayout.setColumns(1);
    gridLayout.setRows(2);
    gridLayout.setHgap(5);
    gridLayout.setVgap(5);
    centerPanel.setLayout(gridLayout);
    
    centerPanel.add(new JLabel("Current skat game"));
    centerPanel.add(new JLabel("Blubb"));
    
    add(centerPanel, BorderLayout.CENTER);
  }

  public void update(Observable observ, Object obj)
  {
    Global.dbgmsg("SkatTabPanel: UPDATE of " + observ + " with " + obj);
    
  }
}
