package ggs.ggsa._skat;

import ggs.ggsa.main.Global;
import ggs.shared.*;

import java.util.Observable;
import java.util.Observer;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.table.AbstractTableModel;

public class TableDataModel extends AbstractTableModel implements Observer
{

  private String[] columnNames = { "Table No.", "Match type",
      "# Free seats min/max", "# Observers", "Action" };

  private Vector<Object[]> data;

  private StdServiceClient ssc;

  public TableDataModel(StdServiceClient ssc)
  {
    this.ssc = ssc;
    
    // fixme: commented out to compile
//     data = new Vector<Object[]>();

//     tableData.addObserver(this);
//     tableInfo = tableData.getTableInfos();
//     tableInfo.addObserver(this);
  }

  public int getColumnCount()
  {
    return columnNames.length;
  }

  public int getRowCount()
  {
    return ssc.tableInfos.size();
  }

  public String getColumnName(int col)
  {
    return columnNames[col];
  }

  public Object getValueAt(int row, int col)
  {
    return data.get(row)[col];
  }

  /*
         * JTable uses this method to determine the default renderer/ editor for
         * each cell. If we didn't implement this method, then the last column
         * would contain text ("true"/"false"), rather than a check box.
         */
  public Class getColumnClass(int c)
  {
    return getValueAt(0, c).getClass();
  }

  /*
         * Don't need to implement this method unless your table's data can
         * change.
         */
  public void setValueAt(Object value, int row, int col)
  {
    if (DEBUG)
    {
      System.out.println("Setting value at " + row + "," + col + " to " + value
	  + " (an instance of " + value.getClass() + ")");
    }

    data.get(row)[col] = value;
    fireTableCellUpdated(row, col);

    if (DEBUG)
    {
      System.out.println("New value of data:");
      printDebugData();
    }
  }

  private void printDebugData()
  {
    int numRows = getRowCount();
    int numCols = getColumnCount();

    for (int i = 0; i < numRows; i++)
    {
      System.out.print("    row " + i + ":");
      for (int j = 0; j < numCols; j++)
      {
	System.out.print("  " + data.get(i)[j]);
      }
      System.out.println();
    }
    System.out.println("--------------------------");
  }

  private boolean DEBUG = false;

  public void update(Observable observ, Object obj)
  {
    Global.dbgmsg("TableDataModel: UPDATE of " + observ + " with " + obj);

    if (observ instanceof StdTableInfo) {
      if (obj instanceof StdTable) {

	StdTable newTable = (StdTable) obj;

	Object[] newRow = {
	  new Integer(newTable.getId()),
	  "to be done",
	  newTable.getMinPlayerNum() + "/" + newTable.getMaxPlayerNum(),
	  new Integer(999/*newTable.getObservers().size()*/),
	  new JButton("Join")
	};

	data.add(newRow);

	fireTableDataChanged();

      } else if (obj instanceof Integer) {

	// fixme: commented out to make it compile
	
// 	StdTable changedTable = tableInfo.getTable((Integer) obj); 
	
// 	Object[] newRow = { new Integer(changedTable.getTableID()), "to be done",
// 	    changedTable.getMinSeats() + "/" + changedTable.getMaxSeats(),
// 	    new Integer(changedTable.getObservers().size()), new JButton("Join") };

// 	// search the row
// 	int row = 0;
// 	while (! ((Integer)getValueAt(row, 0)).equals((Integer) obj)) {
// 	  row++;
// 	}

// 	// write complete row
// 	for (int i = 0; i < getColumnCount(); i++) {
// 	  setValueAt(newRow[i], row, i);
// 	}
	
// 	fireTableDataChanged();
      }
    }

  }
}
