// $Id: BiddingPanel.java,v 1.3 2006/09/04 03:40:42 orts_mburo Exp $

package ggs.ggsa._skat.gui;

import ggs.ggsa.main.Global;

import java.util.Observer;
import java.util.Observable;
import java.awt.GridBagConstraints;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JButton;

import java.awt.GridBagLayout;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * The BiddingPanel that shows the progress of the bidding
 * 
 * @author Jan Sch&auml;fer <j@nschaefer.net>
 */
public class BiddingPanel extends JPanel implements Observer
{

  private static final long serialVersionUID = 1L;

  /**
   * Creates new form BiddingDialog
   */
  public BiddingPanel() {
    initComponents();
  }

  /**
   * This method is called from within the constructor to initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is always
   * regenerated by the Form Editor.
   */
  private void initComponents()
  {
    setOpaque(false);

    GridBagConstraints gridBagConstraints;

    jPanel = new JPanel();
    leftNetworkPlayerPanel = new JPanel();
    leftNetworkPlayerBidField = new JTextField();
    rightNetworkPlayerPanel = new JPanel();
    rightNetworkPlayerBidField = new JTextField();
    humanPlayerBidPanel = new JPanel();
    humanPlayerBidField = new JTextField();
    buttonPanel = new JPanel();
    nextBidButton = new JButton();
    quitButton = new JButton();

    jPanel.setLayout(new GridBagLayout());
    jPanel.setPreferredSize(new Dimension(200, 150));

    leftNetworkPlayerPanel.setLayout(new GridBagLayout());

    leftNetworkPlayerBidField.setHorizontalAlignment(JTextField.CENTER);
    leftNetworkPlayerBidField.setMaximumSize(new Dimension(40, 19));
    leftNetworkPlayerBidField.setMinimumSize(new Dimension(40, 19));
    leftNetworkPlayerBidField.setPreferredSize(new Dimension(40, 19));
    gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.insets = new Insets(10, 10, 10, 10);
    gridBagConstraints.weightx = 1.0;
    leftNetworkPlayerPanel.add(leftNetworkPlayerBidField, gridBagConstraints);

    gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 0;
    gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
    gridBagConstraints.weightx = 1.0;
    jPanel.add(leftNetworkPlayerPanel, gridBagConstraints);

    rightNetworkPlayerPanel.setLayout(new GridBagLayout());

    rightNetworkPlayerBidField.setHorizontalAlignment(JTextField.CENTER);
    rightNetworkPlayerBidField.setMaximumSize(new Dimension(40, 19));
    rightNetworkPlayerBidField.setMinimumSize(new Dimension(40, 19));
    rightNetworkPlayerBidField.setPreferredSize(new Dimension(40, 19));
    gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.insets = new Insets(10, 10, 10, 10);
    rightNetworkPlayerPanel.add(rightNetworkPlayerBidField, gridBagConstraints);

    gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.gridx = 1;
    gridBagConstraints.gridy = 0;
    gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
    gridBagConstraints.weightx = 1.0;
    jPanel.add(rightNetworkPlayerPanel, gridBagConstraints);

    humanPlayerBidPanel.setLayout(new GridBagLayout());

    humanPlayerBidField.setHorizontalAlignment(JTextField.CENTER);
    humanPlayerBidField.setMaximumSize(new Dimension(40, 19));
    humanPlayerBidField.setMinimumSize(new Dimension(40, 19));
    humanPlayerBidField.setPreferredSize(new Dimension(40, 19));
    humanPlayerBidPanel.add(humanPlayerBidField, new GridBagConstraints());

    gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.gridwidth = 2;
    gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
    gridBagConstraints.insets = new Insets(10, 10, 10, 10);
    jPanel.add(humanPlayerBidPanel, gridBagConstraints);

    nextBidButton.setText("   ...   ");
    nextBidButton.validate();
    nextBidButton.setPreferredSize(new Dimension(75, 25));
    nextBidButton.setEnabled(false);
    nextBidButton.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent evt) {
	  nextBidButtonActionPerformed(evt);
	}
      });

    buttonPanel.add(nextBidButton);

    quitButton.setText("Pass");
    quitButton.setEnabled(false);
    quitButton.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent evt) {
	  quitButtonActionPerformed(evt);
	}
      });

    buttonPanel.add(quitButton);

    gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 2;
    gridBagConstraints.gridwidth = 2;
    gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
    gridBagConstraints.insets = new Insets(10, 10, 10, 10);
    jPanel.add(buttonPanel, gridBagConstraints);

    add(jPanel);
  }

  private void resetBiddingPanel()
  {
    humanPlayerBidField.setText("0");
    leftNetworkPlayerBidField.setText("0");
    rightNetworkPlayerBidField.setText("0");
    humanPlayerBidField.setEnabled(true);
    leftNetworkPlayerBidField.setEnabled(true);
    rightNetworkPlayerBidField.setEnabled(true);
    nextBidButton.setText("   ...   ");
    disableButtons();
  }

  private void quitButtonActionPerformed(ActionEvent evt)
  {
    // TODO re-implement it
    //skatGame.notifyBiddingThread(false);
  }

  private void nextBidButtonActionPerformed(ActionEvent evt)
  {
    // TODO re-implement it
    //skatGame.notifyBiddingThread(true);
  }

  private void disableButtons()
  {
    nextBidButton.setEnabled(false);
    quitButton.setEnabled(false);
  }

  private void enableButtons()
  {
    nextBidButton.setEnabled(true);
    quitButton.setEnabled(true);
  }

  /**
   * Implementation of Observer pattern
   * 
   * @param observ
   *            Observable that is observed
   * @param obj
   *            The object that has changed in the Observable
   */
  public void update(Observable observ, Object obj)
  {
    Global.dbgmsg("UPDATE " + observ + ": " + obj + " has changed...");
  }

  private JPanel buttonPanel;
  private JTextField humanPlayerBidField;
  private JPanel humanPlayerBidPanel;
  private JPanel jPanel;
  private JTextField leftNetworkPlayerBidField;
  private JPanel leftNetworkPlayerPanel;
  private JButton nextBidButton;
  private JButton quitButton;
  private JTextField rightNetworkPlayerBidField;
  private JPanel rightNetworkPlayerPanel;
}
