package ggs.ggsa._skat.gui;

import java.awt.BorderLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * A JFrame for playing Skat
 * 
 * @author Jan Sch&auml;fer <j@nschaefer.net>
 */
public class SkatFrame extends JFrame
{
  public SkatFrame(String name) {
		
    initComponents(name);
  }
	
  private void initComponents(String name) {
		
    setTitle(name);
		
    JPanel mainPanel = new JPanel();
    mainPanel.setLayout(new BorderLayout());
		
    mainPanel.add(new JPanel().add(new JLabel("Skat")), BorderLayout.NORTH);
    mainPanel.add(new SkatPlayArea(), BorderLayout.CENTER);
		
    this.setContentPane(mainPanel);
		
    // WindowListener for handling the closing of the main window
    addWindowListener(new WindowAdapter() {
	public void windowClosing(WindowEvent evt) {
	  closeFrame();
	}
      });

    pack();
        
    setVisible(true);
  }
	
  private void closeFrame() {
		
    dispose();
  }
}
