/* $Id: WindowProp.java,v 1.5 2006/08/29 09:10:41 orts_mburo Exp $
   
   (c) Michael Buro, licensed under the GPL2
*/

package ggs.ggsa.boardgamesvc;

import java.util.*;
import java.awt.*;
import java.lang.Error;

import ggs.ggsa.main.*;
import ggs.shared.*;

public class WindowProp
{
  public  String title;
  public  int x=0, y=0;
  private int geom_index = 0;
  private Vector<Geometry> geoms = new Vector<Geometry>();
  private int v_split = 0, h_split = 0;
  
  public WindowProp(String opt_prefix)
  {
    h_split = Global.options.getInteger(opt_prefix+".ipw").intValue();
    v_split = Global.options.getInteger(opt_prefix+".tph").intValue();
    
    for (int i=1;; i++) {
      Geometry geom = Global.options.getGeometry(opt_prefix+".ge"+(i));
      if (geom == null) break;
      geoms.add(geom);
    }

    if (geoms.size() == 0) {
      // default geometry
      geoms.add(new Geometry(400,400,0,0));
    }
  }

  public Geometry get_geom() {
    return geoms.get(geom_index);
  }

  public int get_geom_num() { return geoms.size(); }

  public void set_geom(Geometry g) { geoms.set(geom_index,g ); }

  public void set_index(int i) { 
    if (i < 0 || i >= geoms.size()) 
      Global.errmsg("set_index: index out of range");
    geom_index = i;
  }

  public int get_index() { return geom_index; }

  public int get_hsplit() { return h_split; }
  public int get_vsplit() { return v_split; }  
}
