/* $Id: Bresenham.java,v 1.1.1.1 2006/08/21 04:26:02 orts_mburo Exp $
   
   (c) Michael Buro, licensed under the GPL2
*/

package ggs.ggsa.main;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class Bresenham
{
  public static void drawCircle(Graphics g, int xl, int yu, int diam)
  {
    int a, b, d;
    int xx1, yy1, xx2, yy2;
    int xy1, yx1, xy2, yx2;

    int radius = diam/2;
    int x = xl+radius;
    int y = yu+radius;
    
    a = 0;
    b = radius;
    d = (1 - radius) * 2;

    xx1 = x;
    yy1 = y + b;
    xx2 = x;
    yy2 = y - b;
    xy1 = x + b;
    yx1 = y;
    xy2 = x - b;
    yx2 = y;

    while (b >= a) {

      g.drawLine(xx1, yy1, xx1, yy1);
      g.drawLine(xx1, yy2, xx1, yy2);
      g.drawLine(xx2, yy1, xx2, yy1);
      g.drawLine(xx2, yy2, xx2, yy2);
      g.drawLine(xy1, yx1, xy1, yx1);
      g.drawLine(xy1, yx2, xy1, yx2);
      g.drawLine(xy2, yx1, xy2, yx1);
      g.drawLine(xy2, yx2, xy2, yx2);
    
      if (d + b > 0) {
	b--;
	d -= (b * 2) + 1;
	yy1--;
	yy2++;
	xy1--;
	xy2++;
      }
      if (a > d) {
	a++;
	d += (a * 2) + 1;
	xx1++;
	xx2--;
	yx1++;
	yx2--;
      }
    }
  }

  public static void fillCircle(Graphics g, int xl, int yu, int diam)
  {
    int a, b, d;
    int xx1, yy1, xx2, yy2;
    int xy1, yx1, xy2, yx2;

    int radius = diam/2;
    int x = xl+radius;
    int y = yu+radius;
    
    a = 0;
    b = radius;
    d = (1 - radius) * 2;

    xx1 = x;
    yy1 = y + b;
    xx2 = x;
    yy2 = y - b;
    xy1 = x + b;
    yx1 = y;
    xy2 = x - b;
    yx2 = y;

    while (b >= a) {

      g.drawLine(xx1, yy1, xx1, yy2);
      // g.drawLine(xx1, yy2, xx1, yy2);
      g.drawLine(xx2, yy1, xx2, yy2);
      // g.drawLine(xx2, yy2, xx2, yy2);
      g.drawLine(xy1, yx1, xy1, yx2);
      // g.drawLine(xy1, yx2, xy1, yx2);
      g.drawLine(xy2, yx1, xy2, yx2);
      // g.drawLine(xy2, yx2, xy2, yx2);
    
      if (d + b > 0) {
	b--;
	d -= (b * 2) + 1;
	yy1--;
	yy2++;
	xy1--;
	xy2++;
      }
      if (a > d) {
	a++;
	d += (a * 2) + 1;
	xx1++;
	xx2--;
	yx1++;
	yx2--;
      }
    }
  }

}
