/* $Id: HHMMSS.java,v 1.1.1.1 2006/08/21 04:26:02 orts_mburo Exp $
   
   (c) Michael Buro, licensed under the GPL2
*/

package ggs.ggsa.main;

import java.util.*;

public class HHMMSS
{
  protected long sec;

  public  HHMMSS() { this(0); }
  public  HHMMSS(long s) { sec = s; }

  public long sec() { return sec; }

  public String toString(int w)
  {
    Format f;
    String ts = "";
    final int MM = 60;
    final int HH = 60 * MM;
    final int DD = 24 * HH;
    int r = (int)(sec < 0 ? -sec : sec );
    int dd = r / DD; r %= DD;
    int hh = r / HH; r %= HH;
    int mm = r / MM; r %= MM;
    int ss = r;
    if (sec < 0)
      ts += '-';
    if (dd > 0)
      ts += dd + ".";
    if (dd > 0 || hh > 0 || w >= 8) {
      f = new Format("%02d:");
      ts += f.form(hh);
    }
    if (dd > 0 || hh > 0 || mm > 0 || w >= 5) {
      f = new Format("%02d:");
      ts += f.form(mm);
    }
    f = new Format("%02d");
    ts += f.form(ss);
    while (w > ts.length()) ts += ' ';
    return ts;
  }

  public boolean fromString(String s)
  {
    StringTokenizer st = new StringTokenizer(s, ":");

    String s1="", s2="", s3="";

    if (st.hasMoreTokens()) {
      s1 = st.nextToken();
      if (st.hasMoreTokens()) {
	s2 = st.nextToken();
	if (st.hasMoreTokens()) {
	  s3 = st.nextToken();
	  if (st.hasMoreTokens()) return false;
	}
      }
    }

    try {
      
      if (s3.equals("")) {
	if (s2.equals("")) {
	  sec = Integer.parseInt(s1);
	  return true;
	}
	int m;
	m   = Integer.parseInt(s1);
	sec = Integer.parseInt(s2);
	sec += m * 60;
	return true;
      }
      int h, m;
      h = Integer.parseInt(s1);
      m = Integer.parseInt(s2);
      sec = Integer.parseInt(s3);
      sec += m * 60 + h * 3600;
      if (sec > 24*60*60) return false;
      return true;
    }
    catch (NumberFormatException e) {
      return false;
    }
  }

}

