/* $Id: LimitedTextArea.java,v 1.1.1.1 2006/08/21 04:26:02 orts_mburo Exp $
   
   (c) Michael Buro, licensed under the GPL2
*/

package ggs.ggsa.main;

import java.awt.*;

public class LimitedTextArea extends TextArea
{
  private int limit = 10000;

  public LimitedTextArea() { super(); }
  public LimitedTextArea(int a, int b) { super(a, b); }
  public LimitedTextArea(String s) { super(s); }
  public LimitedTextArea(String s, int a, int b) { super(s, a, b); }
  public LimitedTextArea(String s, int a, int b, int c) { super(s, a, b, c); }

  public void setLimit(int l) { limit = l; }

  private void truncate()
  {
    String s = getText();
    int l = s.length();
    if (l > limit) setText(s.substring(l-limit, l));
  }

  public void clear()
  {
	 setText("");
  }

  public void append(String s)
  {
    int l1 = s.length();
    int l2 = getText().length();

    if (l1+l2 <= limit)
      super.append(s);
    else {
      // super.setText((getText() + s).substring(l1+l2-limit, l1+l2));
      super.append(s);
      super.replaceRange("", 0, l1+l2-limit);
    }
  }

  public void insert(String s, int a)
  {
    super.insert(s,a);
    truncate();
  }

  public void replaceRange(String s, int start, int end)
  {
    super.replaceRange(s,start,end);
    truncate();
  }

  public void setText(String s)
  {
    int l = s.length();
    if (l <= limit)
      super.setText(s);
    else
      super.setText(s.substring(l-limit, l));
  }

}
