/* $Id: USEC.java,v 1.1.1.1 2006/08/21 04:26:02 orts_mburo Exp $
   
   (c) Michael Buro, licensed under the GPL2
*/

package ggs.ggsa.main;

import java.util.*;

public class USEC implements Cloneable
{
  protected long us;
  public static final long uSec = 1000000;
  
  public USEC() {}

  public USEC(long usec) { us = usec; }

  public USEC(USEC x) { this(); copyOf(x); }

  public USEC createCopy() { return new USEC(this); }
  
  public void copyOf(USEC x) { us = x.us; }

  public boolean equals(USEC x)
  {
    if (x == null) return false;
    if (x == this) return true;
    return us == x.us;
  }
  
  public long sec()        { return us / uSec; }
  public long usec()       { return us; }
  public long uadd(long u) { return us += u; }
  public long uset(long u) { return us  = u; }

  public String toString(int w)
  {
    String t;
    long ts = (us < 0 ? -us : us );
    long sec  = us / uSec;
    long msec = ts % uSec; msec /= 1000;
    w -= 4;
    if (w < 0) w = 0;
    t = new HHMMSS((int)sec).toString(w) + '.';
    Format f = new Format("%03lld");
    t += f.form(msec);
    return t;
  }
  
  public boolean fromString(String s)
  {
    HHMMSS hms = new HHMMSS();
    String p1="", p2="";

    StringTokenizer st = new StringTokenizer(s, ".");

    if (st.hasMoreTokens()) {
      p1 = st.nextToken();
      if (st.hasMoreTokens()) {
	p2 = st.nextToken();
      }
    }
       
    if (!hms.fromString(p1)) return false;

    
    if (p2.equals("")) {

      us = 0;

    } else {

      if (p2.startsWith(".")) {
	
	try { us = Long.parseLong(p2); }
	catch (NumberFormatException e) {
	  return false;
	}
      }

      return false;
    }

    us += hms.sec() * uSec;
    return true;
  }
}
