/**
   $Id: Misc.java,v 1.1 2006/08/29 09:10:42 orts_mburo Exp $
   $Source: /usr/bodo1/cvs/cvssoftware/ggs/src/ggs/shared/Misc.java,v $

   Miscellanous functions

   (c) Michael Buro, licensed under GPL2      
*/

package ggs.shared;

import java.util.*;
import java.util.regex.*;

public class Misc
{
  public static void sleep(int n) 
  {
    try { Thread.sleep(n); }
    catch(InterruptedException e) {;}
  }

  public static String center(String s, int len)
  {
    int l = s.length();
    
    if (len < l) {
      
      return s.substring(0, len);
      
    } else {
      
      String t = "";
      for (int i = 0; i < (len-l)/2; i++) t += ' ';
      t += s;
      for (int i = 0; i < (len-l+1)/2; i++) t += ' ';      
      return t;
    }
  }
 
  public static String[] vec2arr(Vector v)
  {
    int n = v.size();
    String[] a = new String[n];
    for (int i=0; i < n; ++i) {
      a[i] = (String) v.elementAt(i);
    }
    return a;
  }

  /**
   * Removes the first String item from the array
   * 
   * @param a The input array
   * @return The output array
   */
  public static String[] remove_first(String[] a) 
  {
    String[] result;	  
    int n = a.length;
	  
    if (n > 0) {
		
      // only remove the first token if there is at least one toke in the array
      result = new String[n-1];
	
      for (int i=0; i < n - 1; ++i) {
	result[i] = a[i+1];
      }
    } else {
		  
      // otherwise return empty array
      result = a;
    }
	  
    return result;
  }


  static public String[] split(String s, String regexp)
  {
    String[] parts = null;

    try { parts = s.split(regexp, 0); }
    catch (PatternSyntaxException e) {
      System.out.println("pattern syntax error: " + regexp);
      System.exit(30);
    }

    return parts;
  }

  public static void msg(String msg)
  {
    System.out.println(msg);
  }

  public static void err(String s)
  {
    msg("*** " + s);
    System.exit(20);
  }
  
}
